package com.ibm.jps.uxtoweb.frontend.custom;

import inputSchema.Heading;
import inputSchema.InputSchemaFactory;
import inputSchema.Screen;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Stereotype;

import com.ibm.xtools.transform.authoring.RuleExtension;

public class Class2ScreenRule implements RuleExtension {

	@SuppressWarnings("unchecked") //$NON-NLS-1$
	public void execute(EObject arg0, EObject arg1) {
		ModelUtil.log("Class2ScreenRule", arg0);
		Class cl = (Class) arg0;
		Screen screen = (Screen) arg1;
		Stereotype st = cl.getAppliedStereotype(Messages.screenStereotype);
		// Screen package
		Element owner = cl.getOwner();
		if (owner instanceof NamedElement) {
			screen.setPackage(ModelUtil.convertToFullJavaName(((NamedElement) owner).getQualifiedName()));
		} else {
			screen.setPackage(Messages.unknownPackage);
		}
        // Heading and headingLevel
        String heading = (String) cl.getValue(st, Messages.headingProperty);
        if (heading != null) {
        	Heading h = InputSchemaFactory.eINSTANCE.createHeading();
        	screen.getHeading().add(h);
        	h.setText(heading);
            Integer hLev = (Integer) cl.getValue(st, Messages.headingLevelProperty);
            // TODO replace by profile constraint??
            if (hLev < 1 || hLev > 6) {
                ModelUtil.addMarker(cl, "headingLevel attribute for <<screen>> stereotype of class " //$NON-NLS-1$
                         + cl.getName() + " outside valid range (1-6): " + hLev + "; defaulting to 2.", //$NON-NLS-1$ //$NON-NLS-2$
                         IMarker.SEVERITY_WARNING);
                hLev = 2;
            }
            h.setLevel(hLev.toString());
        }
        // Title
        String title = (String) cl.getValue(st, Messages.labelProperty);
        if (title == null || title.equals("")) title = ModelUtil.convertToTitle(cl.getName());
        screen.setTitle(title);
	}
}
