package com.ibm.jps.uxtoweb.frontend.custom;

import inputSchema.Database;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.Stereotype;

import com.ibm.xtools.transform.authoring.RuleExtension;

public class Component2DatabaseRule implements RuleExtension {

	public void execute(EObject arg0, EObject arg1) {
		Component comp = (Component) arg0;
		Database db = (Database) arg1;
		Stereotype st = comp.getAppliedStereotype(Messages.databaseStereo);
		
        // Connection parameters
        String s = (String) comp.getValue(st, Messages.connectionDriverClassProp);
        if (s.length() == 0) {
            ModelUtil.addMarker(comp, "Connection Driver Class not defined in <<database>> component "
                    + comp.getName() + ".", IMarker.SEVERITY_WARNING);
        }
        db.setConnectionDriver(s);
        s = (String) comp.getValue(st, Messages.connectionUrlProp);
        if (s.length() == 0) {
            ModelUtil.addMarker(comp, "Connection Url not defined in <<database>> component " + comp.getName()
                     + ".", IMarker.SEVERITY_WARNING);
        }
        db.setConnectionUrl(s);
        s = (String) comp.getValue(st, Messages.connectionUserNameProp);
        db.setConnectionUserName(s);
        s = (String) comp.getValue(st, Messages.connectionPasswordProp);
        db.setConnectionPassword(s);
	}
}
