package com.ibm.jps.uxtoweb.frontend.custom;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.Operation;

public class Operation2ActionInputFilter extends Condition {

	@Override
	public boolean isSatisfied(Object object) {
		ModelUtil.log("Operation2ActionInputFilter", object);
		Operation inOp = (Operation) object;
		if (inOp.getAppliedStereotype(Messages.useractionStereotype) != null) {
			Namespace ns = inOp.getNamespace();
			if (ns  != null && ns instanceof Class) { // Should be a class in all cases
				Class cl = (Class) ns;
				if (ModelUtil.findMatchingOpBean(cl, inOp.getName()) != null) return true;
	            ModelUtil.addMarker(cl, "The useraction " + inOp.getName() + " (in " + cl.getName() + //$NON-NLS-1$ //$NON-NLS-2$
	            		") does not have a matching operation in a supplier bean. This useraction has been ignored.",  //$NON-NLS-1$
	            		IMarker.SEVERITY_WARNING);							
			}
		}
		return false;
	}

}
