package com.ibm.jps.uxtoweb.frontend.custom;

import inputSchema.Action;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Stereotype;

import com.ibm.xtools.transform.authoring.RuleExtension;

public class Operation2ActionRule implements RuleExtension {

	public void execute(EObject arg0, EObject arg1) {
		ModelUtil.log("Operation2ActionRule", arg0);
		Operation inOp = (Operation) arg0;
		Action inAction = (Action) arg1;
		
		// name and visibleOnAction properties: handled directy in the Operation2Action map
		
		// label property
		String label = ModelUtil.convertToTitle(inOp.getName());
		Stereotype st = inOp.getAppliedStereotype(Messages.useractionStereotype);
		if (st != null) {
			String s = (String) inOp.getValue(st, Messages.labelProperty);
			if (s != null && !s.equals("")) label = s;
		}
		inAction.setLabel(label);
		
		// handlerBean property: locate the <<bean>> class among the existing dependency suppliers
		// having a matching operation name (at this stage, we already know it exists)
		Class bean = ModelUtil.findMatchingOpBean((Class) inOp.getNamespace(), inOp.getName()); 
		inAction.setHandlerBean(bean.getName());
		
	}

}
