package com.ibm.jps.uxtoweb.frontend.custom;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.Operation;

public class Operation2ScreenLinkInputFilter extends Condition {

	@Override
	public boolean isSatisfied(Object object) {
		ModelUtil.log("Operation2ScreenLinkInputFilter", object); //$NON-NLS-1$
		Operation inOp = (Operation) object;
		if (inOp.getAppliedStereotype(Messages.linkStereotype) != null) {
			Namespace ns = inOp.getNamespace();
			if (ns  != null && ns instanceof Class) { // Should be a class in all cases
				Class cl = (Class) ns;
				Class tcl = ModelUtil.findAssocClass(cl, Messages.screenStereotype, AggregationKind.NONE_LITERAL, inOp.getName());
				if (tcl != null) return true;
				ModelUtil.addMarker(inOp, "Cannot find target class for <<link>> " + inOp.getName() + " in class " + //$NON-NLS-1$ //$NON-NLS-2$
					cl.getName()+ ". To correct this, add a directed association from the latter to the <<screen>> class the link should point to.", //$NON-NLS-1$
					IMarker.SEVERITY_ERROR);
 			}
		}
		return false;
	}

}
