package com.ibm.jps.uxtoweb.frontend.custom;

import inputSchema.InputField;
import inputSchema.InputSchemaFactory;
import inputSchema.RadioButtonEnum;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.Type;

import com.ibm.xtools.transform.authoring.RuleExtension;

public class Property2InputField implements RuleExtension {

	@SuppressWarnings("unchecked")
	public void execute(EObject arg0, EObject arg1) {
		ModelUtil.log("Property2InputField", arg0);
		Property inProp = (Property) arg0;
		InputField inField = (InputField) arg1;
		// InputField name: done in the Property2InputField map
		// InputField beanName
		Class bean = null;
		Element owner = inProp.getOwner();
		if (owner != null && owner instanceof Class) { // The owner should be the a class!
			bean = ModelUtil.findMatchingBean((Class) owner, inProp.getName());
			if (bean != null) inField.setBeanName(bean.getName()); 
		}
		// Other InputField properties: depend on the actual stereotype
		String label = "";
		for (Object curSt_o:inProp.getAppliedStereotypes()) {
			Stereotype curSt = (Stereotype) curSt_o;
			// InputText (TextField)
			if (curSt.getQualifiedName().equals(Messages.inputtextStereotype)) {
				// label
				label = (String) inProp.getValue(curSt, Messages.labelProperty);
				// type
				inField.setType("TextField");
				// isPassword
				inField.setIsPassword(((Boolean) inProp.getValue(curSt, "password")).booleanValue() ? Messages.trueMark : Messages.falseMark);
				// required
				inField.setRequired(((Boolean) inProp.getValue(curSt, "required")).booleanValue() ? Messages.trueMark : Messages.falseMark);
				// min and max
				String s = "";
				Integer max = (Integer) inProp.getValue(curSt, "max");
				if (max != 0) s = max.toString();
				inField.setMax(s);
				s = "";
				Integer min = (Integer) inProp.getValue(curSt, "min");
				if (min != 0) s = min.toString();
				inField.setMin(s);
			// RadioButton
			} else if (curSt.getQualifiedName().equals(Messages.radiobuttonStereotype)) {
				// label
				label = (String) inProp.getValue(curSt, Messages.labelProperty);
				// type
				inField.setType("RadioButton");
				// radioButtonEnum
				if (bean != null) {
					for (Object curProp_o:bean.getAllAttributes()) {
						Property curProp = (Property) curProp_o;
						if (curProp.getName().equals(inProp.getName())) {
							Type t = curProp.getType();
							if (t != null && t instanceof Enumeration) {
								for (Object enum_o:((Enumeration) t).getOwnedLiterals()) {
									EnumerationLiteral curEnum = (EnumerationLiteral) enum_o;
									RadioButtonEnum rbEnum = InputSchemaFactory.eINSTANCE.createRadioButtonEnum();
									rbEnum.setValue(curEnum.getName());
									inField.getRadioButtonEnum().add(rbEnum);
								}
							}
							break;
						}
					}
				}
			// Listbox
			} else if (curSt.getQualifiedName().equals(Messages.listboxStereotype)) {
				// label
				label = (String) inProp.getValue(curSt, Messages.labelProperty);
				// type
				inField.setType("ListBox");
			}
		}
		// InputField label
        if (label == null || label.equals("")) label = ModelUtil.convertToTitle(inProp.getName());				
        inField.setLabel(label);
	}
}
