package com.ibm.jps.uxtoweb.frontend.custom;

import inputSchema.InputSchemaFactory;
import inputSchema.Item;
import inputSchema.ItemLink;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;

import com.ibm.xtools.transform.authoring.RuleExtension;

public class Property2ItemRule implements RuleExtension {

	@SuppressWarnings("unchecked") //$NON-NLS-1$
	public void execute(EObject arg0, EObject arg1) {
		ModelUtil.log("Property2ItemRule", arg0); //$NON-NLS-1$
		Property prop = (Property) arg0;
		Item item = (Item) arg1;
		Class cl = (Class) prop.getNamespace();
		Class bean = ModelUtil.findMatchingBean(cl,prop.getName());
		item.setParentBean(bean.getName());
		item.setIsSortable(Messages.falseMark); //$NON-NLS-1$
		Stereotype st = prop.getAppliedStereotype(Messages.optionsStereotype); //$NON-NLS-1$
		if (st != null) {
			// TODO Option "sortable": currently only Strings are supported. If this
			// is not the case generate a warning and ignore the setting.
			boolean b = ((Boolean) prop.getValue(st, Messages.sortableProperty)).booleanValue();
			if (b) item.setIsSortable(Messages.trueMark); //$NON-NLS-1$
		}
		st = prop.getAppliedStereotype(Messages.linkStereotype); //$NON-NLS-1$
		if (st != null) {
			Class tcl = ModelUtil.findAssocClass(cl, Messages.screenStereotype, AggregationKind.get(AggregationKind.NONE)); //$NON-NLS-1$
			if (tcl == null) {
				// TODO Error processing if target of link not found
			} else {
				ItemLink link = InputSchemaFactory.eINSTANCE.createItemLink();
				link.setToScreen(tcl.getName());
				item.getItemLink().add(link);
			}
		}
		// Label
		String label = ""; //$NON-NLS-1$
		st = prop.getAppliedStereotype(Messages.displayStereotype);
		if (st != null) { // should not be null
			if (prop.getValue(st, Messages.labelProperty) != null) { //$NON-NLS-1$
				label = (String) prop.getValue(st, Messages.labelProperty); //$NON-NLS-1$
			}
		}
		if (label.equals("")) label = ModelUtil.convertToTitle(prop.getName()); //$NON-NLS-1$
		item.setLabel(label);
	}

}
