/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.jps.uxtoweb.frontend.custom.Class2BeanRule;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;

import com.ibm.jps.uxtoweb.frontend.transforms.Property2FieldTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Property2PrimaryKeyTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.authoring.SubmapExtractor;
import com.ibm.xtools.transform.authoring.uml2.StereotypeCondition;
import com.ibm.xtools.transform.core.AbstractContentExtractor;
import com.ibm.xtools.transform.core.AbstractRule;

/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Class2BeanTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Class2BeanTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Class2Bean_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The ' To ' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String _TO__RULE = TRANSFORM + "_To_Rule";//$NON-NLS-1$
  
   /**
     * The 'OwnedAttribute To BeanPrimaryKey Using Property2PrimaryKey' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ATTRIBUTE_TO_BEAN_PRIMARY_KEY_USING_PROPERTY2PRIMARYKEY_EXTRACTOR = TRANSFORM + "_OwnedAttributeToBeanPrimaryKey_UsingProperty2PrimaryKey_Extractor";//$NON-NLS-1$
  
   /**
     * The 'OwnedAttribute To Field Using Property2Field' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ATTRIBUTE_TO_FIELD_USING_PROPERTY2FIELD_EXTRACTOR = TRANSFORM + "_OwnedAttributeToField_UsingProperty2Field_Extractor";//$NON-NLS-1$
  
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Class2BeanTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Class2Bean_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getTo_Rule());				
        add(getOwnedAttributeToBeanPrimaryKey_UsingProperty2PrimaryKey_Extractor(registry));				
        add(getOwnedAttributeToField_UsingProperty2Field_Extractor(registry));				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.CLASS).AND(new StereotypeCondition(new String[] {"WebModeling::bean"}));			
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Class2Bean_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.BEAN); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getTo_Rule() {
        CustomRule rule = new CustomRule(
            _TO__RULE, 
            UXToWebFrontendMessages.Class2Bean_Transform_To_Rule,
            new Class2BeanRule());

        return rule;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedAttributeToBeanPrimaryKey_UsingProperty2PrimaryKey_Extractor(Registry registry) {
        SubmapExtractor extractor = new SubmapExtractor(
            OWNED_ATTRIBUTE_TO_BEAN_PRIMARY_KEY_USING_PROPERTY2PRIMARYKEY_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Bean_Transform_OwnedAttributeToBeanPrimaryKey_UsingProperty2PrimaryKey_Extractor, 
            registry.get(Property2PrimaryKeyTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.BEAN__BEAN_PRIMARY_KEY)),
            new DirectFeatureAdapter(UMLPackage.Literals.STRUCTURED_CLASSIFIER__OWNED_ATTRIBUTE)); 
      
        extractor.setFilterCondition(new Condition() {
            public boolean isSatisfied(Object object) {
                return filterOwnedAttributeToBeanPrimaryKey_UsingProperty2PrimaryKey_Extractor((Property) object);
            }
        });

        return extractor;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     protected boolean filterOwnedAttributeToBeanPrimaryKey_UsingProperty2PrimaryKey_Extractor(Property ownedAttribute_src) {
        return (ownedAttribute_src.getType() != null);
     }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedAttributeToField_UsingProperty2Field_Extractor(Registry registry) {
        SubmapExtractor extractor = new SubmapExtractor(
            OWNED_ATTRIBUTE_TO_FIELD_USING_PROPERTY2FIELD_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Bean_Transform_OwnedAttributeToField_UsingProperty2Field_Extractor, 
            registry.get(Property2FieldTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.BEAN__FIELD)),
            new DirectFeatureAdapter(UMLPackage.Literals.STRUCTURED_CLASSIFIER__OWNED_ATTRIBUTE)); 
      
        extractor.setFilterCondition(new Condition() {
            public boolean isSatisfied(Object object) {
                return filterOwnedAttributeToField_UsingProperty2Field_Extractor((Property) object);
            }
        });

        return extractor;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     protected boolean filterOwnedAttributeToField_UsingProperty2Field_Extractor(Property ownedAttribute_src) {
        return (ownedAttribute_src.getType() != null);
     }
          
}
