/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import com.ibm.jps.uxtoweb.frontend.custom.Class2ItemListRule;
import com.ibm.jps.uxtoweb.frontend.custom.OwnedAttribute2ItemCondition;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;

import com.ibm.jps.uxtoweb.frontend.transforms.Property2ItemTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.authoring.SubmapExtractor;

import com.ibm.xtools.transform.authoring.uml2.StereotypeCondition;

import com.ibm.xtools.transform.core.AbstractContentExtractor;

import com.ibm.xtools.transform.core.AbstractRule;

import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;

import org.eclipse.uml2.uml.UMLPackage; 


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Class2ItemListTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Class2ItemListTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Class2ItemList_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'OwnedAttribute To Item Using Property2Item' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ATTRIBUTE_TO_ITEM_USING_PROPERTY2ITEM_EXTRACTOR = TRANSFORM + "_OwnedAttributeToItem_UsingProperty2Item_Extractor";//$NON-NLS-1$
	
   /**
     * The ' To ' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String _TO__RULE = TRANSFORM + "_To_Rule";//$NON-NLS-1$
  
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Class2ItemListTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Class2ItemList_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getOwnedAttributeToItem_UsingProperty2Item_Extractor(registry));				
        add(getTo_Rule());				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.CLASS).AND(new StereotypeCondition(new String[] {"WebModeling::list"}));			
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Class2ItemList_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.ITEM_LIST); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedAttributeToItem_UsingProperty2Item_Extractor(Registry registry) {
        SubmapExtractor extractor = new SubmapExtractor(
            OWNED_ATTRIBUTE_TO_ITEM_USING_PROPERTY2ITEM_EXTRACTOR, 
            UXToWebFrontendMessages.Class2ItemList_Transform_OwnedAttributeToItem_UsingProperty2Item_Extractor, 
            registry.get(Property2ItemTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.ITEM_LIST__ITEM)),
            new DirectFeatureAdapter(UMLPackage.Literals.STRUCTURED_CLASSIFIER__OWNED_ATTRIBUTE)); 
      
        extractor.setFilterCondition(new OwnedAttribute2ItemCondition());

        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getTo_Rule() {
        CustomRule rule = new CustomRule(
            _TO__RULE, 
            UXToWebFrontendMessages.Class2ItemList_Transform_To_Rule,
            new Class2ItemListRule());

        return rule;
    }
          
}
