/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.jps.uxtoweb.frontend.custom.Class2ScreenRule;
import com.ibm.jps.uxtoweb.frontend.custom.Operation2ActionInputFilter;
import com.ibm.jps.uxtoweb.frontend.custom.Operation2ScreenLinkInputFilter;
import com.ibm.jps.uxtoweb.frontend.custom.OwnedElement2InputFieldExtractor;
import com.ibm.jps.uxtoweb.frontend.custom.OwnedElement2ItemListExtractor;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;

import com.ibm.jps.uxtoweb.frontend.transforms.Class2ItemListTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Operation2ActionTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Operation2ScreenLinkTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Property2DisplayFieldTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Property2InputFieldTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomExtractor;
import com.ibm.xtools.transform.authoring.CustomRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.MoveRule;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.authoring.SubmapExtractor;
import com.ibm.xtools.transform.authoring.uml2.StereotypeCondition;
import com.ibm.xtools.transform.core.AbstractContentExtractor;
import com.ibm.xtools.transform.core.AbstractRule;


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Class2ScreenTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Class2ScreenTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Class2Screen_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'Name To Name' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NAME_TO_NAME_RULE = TRANSFORM + "_NameToName_Rule";//$NON-NLS-1$
	
   /**
     * The ' To ' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String _TO__RULE = TRANSFORM + "_To_Rule";//$NON-NLS-1$
  
   /**
     * The 'OwnedAttribute To DisplayField Using Property2DisplayField' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ATTRIBUTE_TO_DISPLAY_FIELD_USING_PROPERTY2DISPLAYFIELD_EXTRACTOR = TRANSFORM + "_OwnedAttributeToDisplayField_UsingProperty2DisplayField_Extractor";//$NON-NLS-1$
  
   /**
     * The 'OwnedElement To ItemList Using Class2ItemList' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ELEMENT_TO_ITEM_LIST_USING_CLASS2ITEMLIST_EXTRACTOR = TRANSFORM + "_OwnedElementToItemList_UsingClass2ItemList_Extractor";//$NON-NLS-1$
  
   /**
     * The 'OwnedElement To InputField Using Property2InputField' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ELEMENT_TO_INPUT_FIELD_USING_PROPERTY2INPUTFIELD_EXTRACTOR = TRANSFORM + "_OwnedElementToInputField_UsingProperty2InputField_Extractor";//$NON-NLS-1$
  
   /**
     * The 'OwnedOperation To Action Using Operation2Action' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_OPERATION_TO_ACTION_USING_OPERATION2ACTION_EXTRACTOR = TRANSFORM + "_OwnedOperationToAction_UsingOperation2Action_Extractor";//$NON-NLS-1$
  
   /**
     * The 'OwnedOperation To ScreenLink Using Operation2ScreenLink' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_OPERATION_TO_SCREEN_LINK_USING_OPERATION2SCREENLINK_EXTRACTOR = TRANSFORM + "_OwnedOperationToScreenLink_UsingOperation2ScreenLink_Extractor";//$NON-NLS-1$
  
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Class2ScreenTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Class2Screen_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getNameToName_Rule());				
        add(getTo_Rule());				
        add(getOwnedAttributeToDisplayField_UsingProperty2DisplayField_Extractor(registry));				
        add(getOwnedElementToItemList_UsingClass2ItemList_Extractor(registry));				
        add(getOwnedElementToInputField_UsingProperty2InputField_Extractor(registry));				
        add(getOwnedOperationToAction_UsingOperation2Action_Extractor(registry));				
        add(getOwnedOperationToScreenLink_UsingOperation2ScreenLink_Extractor(registry));				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.CLASS).AND(new StereotypeCondition(new String[] {"WebModeling::screen"}));			
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Class2Screen_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.SCREEN); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getNameToName_Rule() {
        MoveRule rule = new MoveRule(
            NAME_TO_NAME_RULE, 
            UXToWebFrontendMessages.Class2Screen_Transform_NameToName_Rule,
            new DirectFeatureAdapter(UMLPackage.Literals.NAMED_ELEMENT__NAME), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN__NAME));
      
        return rule;            
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getTo_Rule() {
        CustomRule rule = new CustomRule(
            _TO__RULE, 
            UXToWebFrontendMessages.Class2Screen_Transform_To_Rule,
            new Class2ScreenRule());

        return rule;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedAttributeToDisplayField_UsingProperty2DisplayField_Extractor(Registry registry) {
        SubmapExtractor extractor = new SubmapExtractor(
            OWNED_ATTRIBUTE_TO_DISPLAY_FIELD_USING_PROPERTY2DISPLAYFIELD_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Screen_Transform_OwnedAttributeToDisplayField_UsingProperty2DisplayField_Extractor, 
            registry.get(Property2DisplayFieldTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN__DISPLAY_FIELD)),
            new DirectFeatureAdapter(UMLPackage.Literals.STRUCTURED_CLASSIFIER__OWNED_ATTRIBUTE)); 
      
        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedElementToItemList_UsingClass2ItemList_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            OWNED_ELEMENT_TO_ITEM_LIST_USING_CLASS2ITEMLIST_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Screen_Transform_OwnedElementToItemList_UsingClass2ItemList_Extractor, 
            registry.get(Class2ItemListTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN__ITEM_LIST)),
            new OwnedElement2ItemListExtractor());
      
        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedElementToInputField_UsingProperty2InputField_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            OWNED_ELEMENT_TO_INPUT_FIELD_USING_PROPERTY2INPUTFIELD_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Screen_Transform_OwnedElementToInputField_UsingProperty2InputField_Extractor, 
            registry.get(Property2InputFieldTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN__INPUT_FIELD)),
            new OwnedElement2InputFieldExtractor());
      
        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedOperationToAction_UsingOperation2Action_Extractor(Registry registry) {
        SubmapExtractor extractor = new SubmapExtractor(
            OWNED_OPERATION_TO_ACTION_USING_OPERATION2ACTION_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Screen_Transform_OwnedOperationToAction_UsingOperation2Action_Extractor, 
            registry.get(Operation2ActionTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN__ACTION)),
            new DirectFeatureAdapter(UMLPackage.Literals.CLASS__OWNED_OPERATION)); 
      
        extractor.setFilterCondition(new Operation2ActionInputFilter());

        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedOperationToScreenLink_UsingOperation2ScreenLink_Extractor(Registry registry) {
        SubmapExtractor extractor = new SubmapExtractor(
            OWNED_OPERATION_TO_SCREEN_LINK_USING_OPERATION2SCREENLINK_EXTRACTOR, 
            UXToWebFrontendMessages.Class2Screen_Transform_OwnedOperationToScreenLink_UsingOperation2ScreenLink_Extractor, 
            registry.get(Operation2ScreenLinkTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN__SCREEN_LINK)),
            new DirectFeatureAdapter(UMLPackage.Literals.CLASS__OWNED_OPERATION)); 
      
        extractor.setFilterCondition(new Operation2ScreenLinkInputFilter());

        return extractor;
    }
          
}
