/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.jps.uxtoweb.frontend.custom.Model2WebprojectExtractor;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;
import com.ibm.jps.uxtoweb.frontend.transforms.Model2WebTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomExtractor;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.core.AbstractContentExtractor;


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Model2RootTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Model2RootTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Model2Root_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'NestedPackage To Webproject Using Model2Web' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NESTED_PACKAGE_TO_WEBPROJECT_USING_MODEL2WEB_EXTRACTOR = TRANSFORM + "_NestedPackageToWebproject_UsingModel2Web_Extractor";//$NON-NLS-1$
	
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Model2RootTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Model2Root_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getNestedPackageToWebproject_UsingModel2Web_Extractor(registry));				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.MODEL);
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Model2Root_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.ROOT); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getNestedPackageToWebproject_UsingModel2Web_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            NESTED_PACKAGE_TO_WEBPROJECT_USING_MODEL2WEB_EXTRACTOR, 
            UXToWebFrontendMessages.Model2Root_Transform_NestedPackageToWebproject_UsingModel2Web_Extractor, 
            registry.get(Model2WebTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.ROOT__WEBPROJECT)),
            new Model2WebprojectExtractor());
      
        return extractor;
    }
          
}
