/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.jps.uxtoweb.frontend.custom.Model2BeanExtractor;
import com.ibm.jps.uxtoweb.frontend.custom.Model2DatabaseExtractor;
import com.ibm.jps.uxtoweb.frontend.custom.Model2ScreenExtractor;
import com.ibm.jps.uxtoweb.frontend.custom.Model2WebprojectRule;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;
import com.ibm.jps.uxtoweb.frontend.transforms.Class2BeanTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Class2ScreenTransform;
import com.ibm.jps.uxtoweb.frontend.transforms.Component2DatabaseTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomExtractor;
import com.ibm.xtools.transform.authoring.CustomRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.MoveRule;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.core.AbstractContentExtractor;
import com.ibm.xtools.transform.core.AbstractRule;


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Model2WebTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Model2WebTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Model2Web_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'PackagedElement To Bean Using Class2Bean' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String PACKAGED_ELEMENT_TO_BEAN_USING_CLASS2BEAN_EXTRACTOR = TRANSFORM + "_PackagedElementToBean_UsingClass2Bean_Extractor";//$NON-NLS-1$
	
   /**
     * The 'PackagedElement To Database Using Component2Database' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String PACKAGED_ELEMENT_TO_DATABASE_USING_COMPONENT2DATABASE_EXTRACTOR = TRANSFORM + "_PackagedElementToDatabase_UsingComponent2Database_Extractor";//$NON-NLS-1$
	
   /**
     * The 'PackagedElement To Screen Using Class2Screen' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String PACKAGED_ELEMENT_TO_SCREEN_USING_CLASS2SCREEN_EXTRACTOR = TRANSFORM + "_PackagedElementToScreen_UsingClass2Screen_Extractor";//$NON-NLS-1$
	
   /**
     * The ' To ' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String _TO__RULE = TRANSFORM + "_To_Rule";//$NON-NLS-1$
  
   /**
     * The 'Name To Name' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NAME_TO_NAME_RULE = TRANSFORM + "_NameToName_Rule";//$NON-NLS-1$
  
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Model2WebTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Model2Web_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getPackagedElementToBean_UsingClass2Bean_Extractor(registry));				
        add(getPackagedElementToDatabase_UsingComponent2Database_Extractor(registry));				
        add(getPackagedElementToScreen_UsingClass2Screen_Extractor(registry));				
        add(getTo_Rule());				
        add(getNameToName_Rule());				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.MODEL);
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Model2Web_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.WEBPROJECT); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getPackagedElementToBean_UsingClass2Bean_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            PACKAGED_ELEMENT_TO_BEAN_USING_CLASS2BEAN_EXTRACTOR, 
            UXToWebFrontendMessages.Model2Web_Transform_PackagedElementToBean_UsingClass2Bean_Extractor, 
            registry.get(Class2BeanTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.WEBPROJECT__BEAN)),
            new Model2BeanExtractor());
      
        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getPackagedElementToDatabase_UsingComponent2Database_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            PACKAGED_ELEMENT_TO_DATABASE_USING_COMPONENT2DATABASE_EXTRACTOR, 
            UXToWebFrontendMessages.Model2Web_Transform_PackagedElementToDatabase_UsingComponent2Database_Extractor, 
            registry.get(Component2DatabaseTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.WEBPROJECT__DATABASE)),
            new Model2DatabaseExtractor());
      
        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getPackagedElementToScreen_UsingClass2Screen_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            PACKAGED_ELEMENT_TO_SCREEN_USING_CLASS2SCREEN_EXTRACTOR, 
            UXToWebFrontendMessages.Model2Web_Transform_PackagedElementToScreen_UsingClass2Screen_Extractor, 
            registry.get(Class2ScreenTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.WEBPROJECT__SCREEN)),
            new Model2ScreenExtractor());
      
        return extractor;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getTo_Rule() {
        CustomRule rule = new CustomRule(
            _TO__RULE, 
            UXToWebFrontendMessages.Model2Web_Transform_To_Rule,
            new Model2WebprojectRule());

        return rule;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getNameToName_Rule() {
        MoveRule rule = new MoveRule(
            NAME_TO_NAME_RULE, 
            UXToWebFrontendMessages.Model2Web_Transform_NameToName_Rule,
            new DirectFeatureAdapter(UMLPackage.Literals.NAMED_ELEMENT__NAME), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.WEBPROJECT__NAME));
      
        return rule;            
    }
          
}
