/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import inputSchema.Action;
import inputSchema.InputSchemaPackage;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.jps.uxtoweb.frontend.custom.ModelUtil;
import com.ibm.jps.uxtoweb.frontend.custom.Operation2ActionRule;
import com.ibm.jps.uxtoweb.frontend.custom.Operation2ForwardExtractor;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;
import com.ibm.jps.uxtoweb.frontend.transforms.Property2ForwardTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomExtractor;
import com.ibm.xtools.transform.authoring.CustomRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.MoveRule;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.authoring.RuleExtension;
import com.ibm.xtools.transform.authoring.uml2.StereotypeCondition;
import com.ibm.xtools.transform.authoring.uml2.StereotypeFeatureAdapter;
import com.ibm.xtools.transform.core.AbstractContentExtractor;
import com.ibm.xtools.transform.core.AbstractRule;


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Operation2ActionTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Operation2ActionTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Operation2Action_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'Name To Name' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NAME_TO_NAME_RULE = TRANSFORM + "_NameToName_Rule";//$NON-NLS-1$
	
   /**
     * The 'VisibleOnAction To VisibleOnAction' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String VISIBLE_ON_ACTION_TO_VISIBLE_ON_ACTION_RULE = TRANSFORM + "_VisibleOnActionToVisibleOnAction_Rule";//$NON-NLS-1$
	
   /**
     * The ' To ' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String _TO__RULE = TRANSFORM + "_To_Rule";//$NON-NLS-1$
	
   /**
     * The 'OwnedElement To Forward Using Property2Forward' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String OWNED_ELEMENT_TO_FORWARD_USING_PROPERTY2FORWARD_EXTRACTOR = TRANSFORM + "_OwnedElementToForward_UsingProperty2Forward_Extractor";//$NON-NLS-1$
  
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Operation2ActionTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Operation2Action_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getNameToName_Rule());				
        add(getTo_Rule());				
        add(getOwnedElementToForward_UsingProperty2Forward_Extractor(registry));				
        add(getVisibleOnActionToVisibleOnAction_Rule());				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.OPERATION).AND(new StereotypeCondition(new String[] {"WebModeling::useraction"}));			
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Operation2Action_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.ACTION); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getNameToName_Rule() {
        CustomRule rule = new CustomRule(
            NAME_TO_NAME_RULE, 
            UXToWebFrontendMessages.Operation2Action_Transform_NameToName_Rule,
            new RuleExtension() {
                public void execute(EObject source, EObject target) {
                    executeNameToName_Rule((Operation) source, (Action) target);
                }
            });

        return rule;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
     protected void executeNameToName_Rule(Operation Operation_src, Action Action_tgt) {
        Action_tgt.setName(ModelUtil.firstCharToLowerCase(Operation_src.getName()));
     }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getVisibleOnActionToVisibleOnAction_Rule() {
        MoveRule rule = new MoveRule(
            VISIBLE_ON_ACTION_TO_VISIBLE_ON_ACTION_RULE, 
            UXToWebFrontendMessages.Operation2Action_Transform_VisibleOnActionToVisibleOnAction_Rule,
            new StereotypeFeatureAdapter("WebModeling::useraction::visibleOnAction"), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.ACTION__VISIBLE_ON_ACTION));
      
        return rule;            
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getTo_Rule() {
        CustomRule rule = new CustomRule(
            _TO__RULE, 
            UXToWebFrontendMessages.Operation2Action_Transform_To_Rule,
            new Operation2ActionRule());

        return rule;
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getOwnedElementToForward_UsingProperty2Forward_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            OWNED_ELEMENT_TO_FORWARD_USING_PROPERTY2FORWARD_EXTRACTOR, 
            UXToWebFrontendMessages.Operation2Action_Transform_OwnedElementToForward_UsingProperty2Forward_Extractor, 
            registry.get(Property2ForwardTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.ACTION__FORWARD)),
            new Operation2ForwardExtractor());
      
        return extractor;
    }
          
}
