/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.jps.uxtoweb.frontend.custom.Operation2ScreenLinkRule;
import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;
import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.MoveRule;
import com.ibm.xtools.transform.authoring.Registry;
import com.ibm.xtools.transform.authoring.uml2.StereotypeCondition;
import com.ibm.xtools.transform.authoring.uml2.StereotypeFeatureAdapter;
import com.ibm.xtools.transform.core.AbstractRule;


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Operation2ScreenLinkTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Operation2ScreenLinkTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Operation2ScreenLink_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'Name To Name' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NAME_TO_NAME_RULE = TRANSFORM + "_NameToName_Rule";//$NON-NLS-1$
	
   /**
     * The 'Description To Description' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String DESCRIPTION_TO_DESCRIPTION_RULE = TRANSFORM + "_DescriptionToDescription_Rule";//$NON-NLS-1$
	
   /**
     * The ' To ' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String _TO__RULE = TRANSFORM + "_To_Rule";//$NON-NLS-1$
	
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Operation2ScreenLinkTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Operation2ScreenLink_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getNameToName_Rule());				
        add(getDescriptionToDescription_Rule());				
        add(getTo_Rule());				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.OPERATION).AND(new StereotypeCondition(new String[] {"WebModeling::link"}));			
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Operation2ScreenLink_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.SCREEN_LINK); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getNameToName_Rule() {
        MoveRule rule = new MoveRule(
            NAME_TO_NAME_RULE, 
            UXToWebFrontendMessages.Operation2ScreenLink_Transform_NameToName_Rule,
            new DirectFeatureAdapter(UMLPackage.Literals.NAMED_ELEMENT__NAME), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN_LINK__NAME));
      
        return rule;            
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getDescriptionToDescription_Rule() {
        MoveRule rule = new MoveRule(
            DESCRIPTION_TO_DESCRIPTION_RULE, 
            UXToWebFrontendMessages.Operation2ScreenLink_Transform_DescriptionToDescription_Rule,
            new StereotypeFeatureAdapter("WebModeling::link::description"), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.SCREEN_LINK__DESCRIPTION));
      
        return rule;            
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getTo_Rule() {
        CustomRule rule = new CustomRule(
            _TO__RULE, 
            UXToWebFrontendMessages.Operation2ScreenLink_Transform_To_Rule,
            new Operation2ScreenLinkRule());

        return rule;
    }
          
}
