/**
 * <copyright>
 * </copyright>
 */
package com.ibm.jps.uxtoweb.frontend.transforms;


import com.ibm.jps.uxtoweb.frontend.l10n.UXToWebFrontendMessages;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.MoveRule;
import com.ibm.xtools.transform.authoring.Registry;

import com.ibm.xtools.transform.authoring.uml2.StereotypeCondition;

import com.ibm.xtools.transform.core.AbstractRule;

import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;

import org.eclipse.uml2.uml.UMLPackage; 


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Property2PrimaryKeyTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Property2PrimaryKeyTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Property2PrimaryKey_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'Name To Name' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NAME_TO_NAME_RULE = TRANSFORM + "_NameToName_Rule";//$NON-NLS-1$
	
   /**
     * The 'Type$Name To Type' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TYPE$NAME_TO_TYPE_RULE = TRANSFORM + "_Type$NameToType_Rule";//$NON-NLS-1$
	
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Property2PrimaryKeyTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, UXToWebFrontendMessages.Property2PrimaryKey_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getNameToName_Rule());				
        add(getType$NameToType_Rule());				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.PROPERTY).AND(new StereotypeCondition(new String[] {"DataModeling::pk"}));			
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            UXToWebFrontendMessages.Property2PrimaryKey_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.BEAN_PRIMARY_KEY); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getNameToName_Rule() {
        MoveRule rule = new MoveRule(
            NAME_TO_NAME_RULE, 
            UXToWebFrontendMessages.Property2PrimaryKey_Transform_NameToName_Rule,
            new DirectFeatureAdapter(UMLPackage.Literals.NAMED_ELEMENT__NAME), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.BEAN_PRIMARY_KEY__NAME));
      
        return rule;            
    }
          
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getType$NameToType_Rule() {
        MoveRule rule = new MoveRule(
            TYPE$NAME_TO_TYPE_RULE, 
            UXToWebFrontendMessages.Property2PrimaryKey_Transform_Type$NameToType_Rule,
            new DirectFeatureAdapter(UMLPackage.Literals.TYPED_ELEMENT__TYPE, "name"), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.BEAN_PRIMARY_KEY__TYPE));
      
        return rule;            
    }
          
}
